package org.nakedobjects.testing;

import java.awt.Color;
import java.awt.Font;
import java.util.Enumeration;
import java.util.Hashtable;

import junit.framework.AssertionFailedError;

import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.core.util.NakedObjectConfiguration;
import org.nakedobjects.nof.core.util.NotImplementedException;


public class TestConfiguration implements NakedObjectConfiguration {

    private Hashtable values = new Hashtable();
    
    public void add(String name, String value) {
        if(values.containsKey(name)) {
            throw new AssertionFailedError("Already have a value for " + " name; cannot set it again: " + value);
        }
        values.put(name, value);
    }

    public boolean getBoolean(String name) {
        return Boolean.valueOf(getString(name)).booleanValue();
    }

    public boolean getBoolean(String name, boolean defaultValue) {
        String str = getString(name);
        return str == null ? defaultValue : Boolean.valueOf(str).booleanValue();
    }

    public Color getColor(String name) {
        throw new NotImplementedException();
    }

    public Color getColor(String name, Color defaultColor) {
        return defaultColor;
    }

    public Font getFont(String name) {
        throw new NotImplementedException();
    }

    public Font getFont(String name, Font defaultValue) {
        return defaultValue;
    }

    public int getInteger(String name) {
        return Integer.valueOf(getString(name)).intValue();
    }

    public int getInteger(String name, int defaultValue) {
        String str = getString(name);
        return str == null ? defaultValue : Integer.valueOf(str).intValue();
    }

    public String[] getList(String name) {
        return null;
    }
    
    public NakedObjectConfiguration getProperties(String withPrefix) {
        throw new NotImplementedException();
    }

    public String getString(String name) {
        return (String) values.get(name);
    }

    public String getString(String name, String defaultValue) {
        String str = getString(name);
        return str == null ? defaultValue : str;
    }

    public boolean hasProperty(String name) {
        throw new NotImplementedException();
    }

    public String referedToAs(String name) {
        throw new NotImplementedException();
    }

    public NakedObjectConfiguration createSubset(String prefix) {
        throw new NotImplementedException();
    }

    public boolean isEmpty() {
        throw new NotImplementedException();
    }

    public int size() {
        throw new NotImplementedException();
    }

    public Enumeration propertyNames() {
        throw new NotImplementedException();
    }

    public String rootPath() {
        return null;
    }
    
    public void debugData(DebugString debug) {}

    public String debugTitle() {
        throw new NotImplementedException();
    }

}
// Copyright (c) Naked Objects Group Ltd.
