package org.nakedobjects.testing;

import java.util.Hashtable;

import org.nakedobjects.noa.adapter.Naked;
import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.adapter.NakedValue;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.reflect.Formatter;
import org.nakedobjects.noa.reflect.ValueAssociation;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.reflect.Allow;
import org.nakedobjects.nof.core.util.UnexpectedCallException;


public class TestValueAssociation implements ValueAssociation {
    private final String name;
    private final Hashtable values = new Hashtable();

    public TestValueAssociation(String name2, String name, TestSpecification valueFieldSpec) {
        this.name = name;
    }

    public boolean canClear() {
        return false;
    }
    
    public boolean canWrap() {
        return false;
    }

    public void clearValue(NakedObject inObject) {}

    public String debugData() {
        return "";
    }

    public Naked get(NakedObject inObject) {
        return (Naked) values.get(inObject);
    }

    public String getBusinessKeyName() {
        return null;
    }
    
    public String getDescription() {
        return "no description";
    }

    public Object getExtension(final Class cls) {
        throw new UnexpectedCallException();
    }
    
    public Class[] getExtensions() {
        return new Class[0];
    }

    public Formatter getFormatter() {
        return null;
    }

    public String getHelp() {
        return "no help";
    }

    public String getId() {
        return name;
    }

    public int getMaximumLength() {
        return 0;
    }
    
    public String getName() {
        return name;
    }
    
    public int getNoLines() {
        return 0;
    }
    
    public Naked[] getOptions(final NakedObject target) {
        return null;
    }

    public NakedObjectSpecification getSpecification() {
        throw new UnexpectedCallException();
    }

    public int getTypicalLineLength() {
        return 0;
    }

    public void initValue(final NakedObject inObject, final NakedValue associate) {
        setValue(inObject, associate);
    }

    public boolean isCollection() {
        return false;
    }

    public boolean isPersisted() {
        return true;
    }

    public boolean isEmpty(final NakedObject inObject) {
        throw new UnexpectedCallException();
    }

    public boolean isMandatory() {
        throw new UnexpectedCallException();
    }

    public boolean isObject() {
        return false;
    }

    public boolean isOptionEnable() {
        return false;
    }

    public Consent isUsable() {
        Consent usableDeclaratively = isUsableDeclaratively();
        if (usableDeclaratively.isVetoed()) {
            return usableDeclaratively;
        }
        return isUsableForSession();
    }

    public Consent isUsableDeclaratively() {
        return Allow.DEFAULT;
    }

    public Consent isUsableForSession() {
        return Allow.DEFAULT;
    }

    public Consent isUsable(final NakedReference target) {
        throw new UnexpectedCallException();
    }

    public boolean isValue() {
        return true;
    }

    public Consent isValueValid(final NakedObject inObject, final NakedValue value) {
        throw new UnexpectedCallException();
    }

    public boolean isVisible() {
        return isVisibleDeclaratively() && isVisibleForSession(); 
    }

    public boolean isVisibleDeclaratively() {
        throw new UnexpectedCallException();
    }
    
    public boolean isVisibleForSession() {
        throw new UnexpectedCallException();
    }

    public boolean isVisible(final NakedReference target) {
        throw new UnexpectedCallException();
    }

    public void setValue(final NakedObject inObject, final NakedValue value) {
        values.put(inObject, value);
    }
    
    public Object getDefault(
            NakedObject nakedObject) {
        return null;
    }

    public void toDefault(NakedObject target) {}


}
// Copyright (c) Naked Objects Group Ltd.
